"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var _constants_1 = require("../constants");
var comments_1 = require("./comments");
var rules_1 = require("./rules");
exports.walkContainer = function (container, filter, removeComments, callback) {
    var ignoreMode = _constants_1.IGNORE_MODE.DISABLED;
    container.each(function (node) {
        if (node.type !== _constants_1.COMMENT_TYPE && !filter.includes(node.type))
            return;
        if (node.type === _constants_1.COMMENT_TYPE) {
            var comment = node;
            var ignore = comments_1.getIgnoreComment(comment);
            if (ignore) {
                if (removeComments) {
                    rules_1.cleanRuleRawsBefore(comment.next());
                    comment.remove();
                }
                switch (ignore) {
                    case _constants_1.IGNORE_BEGIN:
                        ignoreMode = _constants_1.IGNORE_MODE.BLOCK_MODE;
                        break;
                    case _constants_1.IGNORE_END:
                        ignoreMode = _constants_1.IGNORE_MODE.DISABLED;
                        break;
                    default:
                        ignoreMode = _constants_1.IGNORE_MODE.NEXT_NODE;
                        break;
                }
                return;
            }
        }
        else {
            if (ignoreMode === _constants_1.IGNORE_MODE.NEXT_NODE) {
                ignoreMode = _constants_1.IGNORE_MODE.DISABLED;
                return;
            }
            if (ignoreMode === _constants_1.IGNORE_MODE.BLOCK_MODE) {
                return;
            }
            callback(node);
        }
    });
};
